// --------------------------------------------------------------------
//  Windows Application Basic Classes
// --------------------------------------------------------------------
//

#include <windows>
#include <stdio>
#include "winlib.h"

//#define _WINLIB_DEBUG_

HINSTANCE ApplicationInstance ;

int NoticeMessage(char *message)
{
	MessageBox(HWND_DESKTOP,message,"Notice!",MB_OK) ;
	return(1) ;
}

int NoticeMessagef(char *format,...)
{
	char buff[4096] ;
	int len ;
	va_list ap ;
	va_start(ap,format) ;
//	len=_vscprintf(format,ap) ; // 񒷂擾
//	if(NULL==(buff=(char *)malloc(len+2))){
//	  va_end(ap) ; return(0) ;
//	}
	vsnprintf(buff,4096,format,ap) ;
	va_end(ap) ;
	NoticeMessage(buff) ;
//	free(buff) ;
	return(1) ;
}

#ifdef _WINLIB_DEBUG_

#include <stdio>
#define DEBUGLOGFILE "WLDEBUG.log"

class _DEBUGLOG_{
	private:
	  FILE *debugfp ;
	  BOOL DbgEn ;
	public:
	  _DEBUGLOG_(){
	    debugfp=fopen(DEBUGLOGFILE,"w") ;
	    if(debugfp==NULL) DbgEn=FALSE ;
	    else              DbgEn=TRUE ;
	  } ;
	  ~_DEBUGLOG_(){ if(DbgEn) fclose(debugfp) ; } ;
	  void log(char *str){ if(DbgEn) fprintf(debugfp,str) ; } ;
	  void log(int x){ if(DbgEn) fprintf(debugfp,"%d",x) ; } ;
	  void log(long lx){ if(DbgEn) fprintf(debugfp,"%ld",lx) ; }
} ;

_DEBUGLOG_ WLDEBUG ;
#endif

WindowClass::WindowClass(HINSTANCE hInstance,WNDPROC WndPrc,char *Cname)
{
	strcpy(ClassName,Cname) ;
	hI=hInstance ;
	ApplicationInstance=hI ;
	wc.cbSize           = sizeof(WNDCLASSEX) ;
	wc.style            = CS_HREDRAW | CS_VREDRAW ; /* WindowX^C */
	wc.lpfnWndProc      = WndPrc ;                 /* Cxgnh̒` */
	wc.cbClsExtra       = 0 ;
	wc.cbWndExtra       = 0 ;
	wc.hInstance        = hInstance ;               /* ̃CX^XZbg */
	wc.hIcon            = NULL ;
	wc.hCursor          = LoadCursor(NULL,IDC_ARROW) ; 
	wc.hbrBackground    = (HBRUSH)GetStockObject(LTGRAY_BRUSH) ;
	wc.lpszMenuName     = NULL ;
	wc.lpszClassName    = (LPCTSTR)ClassName ;
}

void WindowClass::SetIcon(char *iconname)
{
	strcpy(IconName,iconname) ;
	wc.hIcon=LoadIcon(hI,(LPCTSTR)IconName) ;
}

void WindowClass::SetMenu(char *menuname)
{
	strcpy(MenuName,menuname) ;
	wc.lpszMenuName=(LPCTSTR)MenuName ;
}

void WindowClass::SetBackground(int brush_type)
{
	wc.hbrBackground=(HBRUSH)GetStockObject(brush_type) ;
}

void WindowClass::SetCbWExtra(int cbex)
{
	wc.cbWndExtra=cbex ;
}

void WindowClass::SetAll(WNDCLASSEX wx)
{
//	wc.cbSize = wx.cbSize ;
	wc.style        =wx.style ;
	wc.lpfnWndProc  =wx.lpfnWndProc ;
	wc.cbClsExtra   =wx.cbClsExtra ;
	wc.cbWndExtra   =wx.cbWndExtra ;
	wc.hInstance    =wx.hInstance ;
	wc.hIcon        =wx.hIcon ;
	wc.hCursor      =wx.hCursor ;
	wc.hbrBackground=wx.hbrBackground ;
	wc.lpszMenuName =wx.lpszMenuName ;
	wc.lpszClassName=wx.lpszClassName ;
	ApplicationInstance=wx.hInstance ;
}

ATOM WindowClass::Regist(void)
{
	return(RegisterClassEx(&wc)) ;
}

// --------------------------------------------------------------------
//  i
// --------------------------------------------------------------------

//MainWindow::MainWindow(HINSTANCE hi,char *Cname)
//{
//	apInst=hi ;
//	strcpy(ClassName,Cname) ;
//	Style=WS_OVERLAPPEDWINDOW ;
//	handleWnd=NULL ;
//}

//void MainWindow::SetStyle(DWORD style)
//{
//	Style=style ;
//}

//HWND MainWindow::Create(char *title,int sx,int sy,int wd,int ht,BOOL sw)
//{
//	if(sx<0) sx=CW_USEDEFAULT ;
//	if(sy<0) sy=CW_USEDEFAULT ;
//	if(sw){
//	  wd=wd+GetSystemMetrics(SM_CXBORDER)*2 ;
//	  ht=ht+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU)
//	     +GetSystemMetrics(SM_CYBORDER)*2 ;
//	}
//	handleWnd=CreateWindow((LPCTSTR)ClassName,title,Style,
//	sx,sy,wd,ht,NULL,NULL,apInst,NULL) ;
//	return(handleWnd) ;
//}

//void MainWindow::Show(int cmdshow)
//{
//	if(handleWnd==NULL) return ;
//	ShowWindow(handleWnd,cmdshow) ;
//	UpdateWindow(handleWnd) ;
//}

//HWND MainWindow::GetHandle(void)
//{
//	return(handleWnd) ;
//}

//WPARAM MainWindow::MessageLoop(void)
//{
//	MSG msg ;
//	while (GetMessage(&msg,NULL,0,0)) {
//	  TranslateMessage(&msg) ;
//	  DispatchMessage(&msg) ;
//	}
//	return(msg.wParam) ;
//}

// --------------------------------------------------------------------
// --------------------------------------------------------------------

//MainWin::MainWin(HINSTANCE hi,WNDPROC WndPrc,char *Cname) : WindowClass(hi,WndPrc,Cname)
//{
//	apInst=hi ;
//	strcpy(ClassName,Cname) ;
//	Style=WS_OVERLAPPEDWINDOW ;
//	handleWnd=NULL ;
//}

//void MainWin::SetStyle(DWORD style)
//{
//	Style=style ;
//}

//HWND MainWin::Create(char *title,int sx,int sy,int wd,int ht,BOOL sw)
//{
//	if(sx<0) sx=CW_USEDEFAULT ;
//	if(sy<0) sy=CW_USEDEFAULT ;
//	if(sw){
//	  wd=wd+GetSystemMetrics(SM_CXBORDER)*2 ;
//	  ht=ht+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU)
//	     +GetSystemMetrics(SM_CYBORDER)*2 ;
//	}
//	handleWnd=CreateWindow((LPCTSTR)ClassName,title,Style,
//	sx,sy,wd,ht,NULL,NULL,apInst,NULL) ;
//	return(handleWnd) ;
//}

//void MainWin::Show(int cmdshow)
//{
//	if(handleWnd==NULL) return ;
//	ShowWindow(handleWnd,cmdshow) ;
//	UpdateWindow(handleWnd) ;
//}

//HWND MainWin::GetHandle(void)
//{
//	return(handleWnd) ;
//}

//WPARAM MainWin::MessageLoop(void)
//{
//	MSG msg ;
//	while (GetMessage(&msg,NULL,0,0)) {
//	  TranslateMessage(&msg) ;
//	  DispatchMessage(&msg) ;
//	}
//	return(msg.wParam) ;
//}

//int  MainWin::MessageBox(char *msg,char *captn,UINT typ)
//{
//	return(::MessageBox(handleWnd,msg,captn,typ)) ;
//}

COLORREF RGBcolor(int r,int g,int b)
{
	COLORBYTES clr ;
	clr.lcolor=0l ;
	clr.param.red=r ;
	clr.param.green=g ;
	clr.param.blue=b ;
	return((COLORREF)clr.lcolor) ;
}

class SerialNumberGenerator{
	private:
	  int Number ;
	public:
	  SerialNumberGenerator(){ Number=0 ; }
	  int GetNextNumber(void){ Number++ ; return(Number) ; }
} ;

SerialNumberGenerator ClsNameN ;

// --------------------------------------------------------------------
//  DragDrop Method
// --------------------------------------------------------------------

DragDrop::DragDrop(WPARAM wParam)
{
	int i ;
	handleDrop=(HDROP)wParam ;
	DropCount=DragQueryFile(handleDrop,-1,NULL,0) ;
	for(i=0 ; i<DropCount ; i++){
	  DragQueryFile((HDROP)wParam,0,tmpFN,255) ;
	  if(i<DRAGDROPMAX){ // MAXȏ́AǂݏoǁAi[Ȃ
	    tmpFname[i]=new tempString(tmpFN) ;
	  }
	}
	if(DropCount>DRAGDROPMAX) DropCount=DRAGDROPMAX ;
	DragFinish(handleDrop) ;
}

DragDrop::~DragDrop()
{
	int i ;
	for(i=0 ; i<DropCount ; i++) delete tmpFname[i] ;
}

BOOL DragDrop::compare_extention(char *ext)
{
	int fl,l,i,c1,c2 ;
	fl=strlen(tmpFN) ;
	l=strlen(ext) ;
	if(l==0) return(FALSE) ;
	if(l>fl) return(FALSE) ;
	if(ext[0]=='*') return(TRUE) ;
	for(i=0 ; i<l ; i++){
	  c1=tmpFN[fl-i] ; if(c1>0x60) c1-=0x20 ;
	  c2=ext[l-i] ;       if(c2>0x60) c2-=0x20 ;
	  if(c1!=c2) return(FALSE) ;
	}
	return(TRUE) ;
}

char *DragDrop::GetFilename(char *search_extention)
{
	int i ;
	for(i=0 ; i<DropCount ; i++){
	  strcpy(tmpFN,tmpFname[i]->get()) ;
	  if(compare_extention(search_extention)) return(tmpFN) ;
	}
	return(NULL) ;
}

char DummyString[4]={0x00,0x00,0x00,0x00} ;

// --------------------------------------------------------------------
//  ʂ̃EChEvV[W

LRESULT CALLBACK CmnWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	LPCREATESTRUCT lpcs ;
	WinApp *ThisClass=(WinApp*)GetWindowLong(hwnd,0) ;
	// /*GWL_USERDATA*/) ;
	if(ThisClass==0){
	  if(msg==WM_CREATE){
	    lpcs=(LPCREATESTRUCT)lParam ;
	    ThisClass=(WinApp*)lpcs->lpCreateParams ;
	    SetWindowLong(hwnd,0,(LONG)ThisClass) ;
	  }
	  else return DefWindowProc(hwnd,msg,wParam,lParam) ;
	}
	return ThisClass->WindowProc(hwnd,msg,wParam,lParam) ;
}

void WinApp::InitialWinApp(HINSTANCE hi,WNDPROC WPRC,char *Cname)
{
	int i ;
	apInst=hi ;
	WndClass=new WindowClass(hi,WPRC,Cname) ;
	strcpy(ClassName,Cname) ;
	Style=WS_OVERLAPPEDWINDOW ;
	dwExStyle=WS_EX_CLIENTEDGE ;
	handleWnd=NULL ;
	UseTimer=FALSE ;
	for(i=0 ; i<256 ; i++) CWndColor[i].SETPARAM=0 ;
	ColorCount=0 ;
}

void WinApp::ChildWndColor(COLORSET *tmpColor)
{
	int i ;
	for(i=0 ; i<ColorCount ; i++){
	  if((CWndColor[i].WNDHANDLE)==tmpColor->WNDHANDLE){
	    CWndColor[i].TEXTCOLOR=tmpColor->TEXTCOLOR ;
	    CWndColor[i].BACKGROUND=tmpColor->BACKGROUND ;
	    CWndColor[i].SETPARAM=tmpColor->SETPARAM ;
	    return ;
	  }
	}
	if(ColorCount<256){
	  CWndColor[ColorCount].WNDHANDLE=tmpColor->WNDHANDLE ;
	  CWndColor[ColorCount].TEXTCOLOR=tmpColor->TEXTCOLOR ;
	  CWndColor[ColorCount].BACKGROUND=tmpColor->BACKGROUND ;
	  CWndColor[ColorCount].SETPARAM=tmpColor->SETPARAM ;
	  ColorCount++ ;
	}
}

void WinApp::ChildWndPartsColor(LPARAM lP)
{
	int i ;
	COLORSET *tempColor ;
	tempColor=(COLORSET *)lP ;
	ChildWndColor(tempColor) ;
}

LRESULT WinApp::ControlChildColor(HDC childDC,HWND childHnd)
{
	int i,t ;
	for(i=0 ; i<ColorCount ; i++){
	  if(childHnd==CWndColor[i].WNDHANDLE){
	    t=CWndColor[i].SETPARAM ;
	    if(t&0x0001) SetTextColor(childDC,CWndColor[i].TEXTCOLOR) ;
	    if(t&0x0004){
	      SetBkMode(childDC,OPAQUE) ;
	      SetBkColor(childDC,CWndColor[i].TEXTBG) ;
	    }
	    if(t&0x0002) return((LRESULT)CWndColor[i].BACKGROUND) ;
	    else return(0l) ;
	  }
	}
	return(-1) ;
}

WinApp::WinApp(HINSTANCE hi,WNDPROC WndPrc,char *Cname) 
{
	InitialWinApp(hi,WndPrc,Cname) ;
	UseCommon=FALSE ;
}

WinApp::WinApp(HINSTANCE hi,char *Cname)
{
	InitialWinApp(hi,CmnWndProc,Cname) ;
	UseCommon=TRUE ;
	WndClass->SetCbWExtra((int)sizeof(WinApp*)) ;
}

WinApp::WinApp(HINSTANCE hi)
{
	char ClsName[64] ;
	wsprintf(ClsName,"WL%03d",ClsNameN.GetNextNumber()) ;
	InitialWinApp(hi,CmnWndProc,ClsName) ;
	UseCommon=TRUE ;
	WndClass->SetCbWExtra((int)sizeof(WinApp*)) ;
}

void WinApp::SetStyle(DWORD style)
{
	Style=style ;
}

void WinApp::SetExStyle(DWORD Exstyle)
{
	dwExStyle=Exstyle ;
}

HWND WinApp::Create(char *title,int sx,int sy,int wd,int ht,BOOL sw)
{
	if(sx<0) sx=CW_USEDEFAULT ;
	if(sy<0) sy=CW_USEDEFAULT ;
	if(sw){
	  wd=wd+GetSystemMetrics(SM_CXBORDER)*2 ;
	  ht=ht+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU)
	     +GetSystemMetrics(SM_CYBORDER)*2 ;
	}
	if(UseCommon) 
	  handleWnd=CreateWindowEx(dwExStyle,(LPCTSTR)ClassName,title,Style,
	              sx,sy,wd,ht,NULL,NULL,apInst,(LPSTR)this) ;
	else
	  handleWnd=CreateWindow((LPCTSTR)ClassName,title,Style,
	              sx,sy,wd,ht,NULL,NULL,apInst,NULL) ;
//	OnCreate(handleWnd) ;
	return(handleWnd) ;
}

void WinApp::Show(int cmdshow)
{
	if(handleWnd==NULL) return ;
	ShowWindow(handleWnd,cmdshow) ;
	UpdateWindow(handleWnd) ;
}

HWND WinApp::GetHandle(void)
{
	return(handleWnd) ;
}

WPARAM WinApp::MessageLoop(void)
{
	MSG msg ;
	while (GetMessage(&msg,NULL,0,0)) {
	  TranslateMessage(&msg) ;
	  DispatchMessage(&msg) ;
	}
	return(msg.wParam) ;
}

int  WinApp::MessageBox(char *msg,char *captn,UINT typ)
{
	return(::MessageBox(handleWnd,msg,captn,typ)) ;
}

char *WinApp::GetDropFilename(WPARAM wP,char *extention)
{
	char *GFileName ;
	DragDrop DDrop(wP) ;
	if(NULL!=(GFileName=DDrop.GetFilename(extention)))
	  return(GFileName) ;
	else return((char *)DummyString) ;
}

LRESULT WinApp::OnCtlColor(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	LRESULT Rval ;
	Rval=ControlChildColor((HDC)wParam,(HWND)lParam) ;
	if(Rval==-1) return(DefWindowProc(hwnd,msg,wParam,lParam)) ;
	else return(Rval) ;
}

LRESULT WinApp::WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT ps ;
	switch(msg){
	  case WM_CREATE: handleWnd=hwnd ;
	                  OnCreate(hwnd) ; break ;
	  case WM_DESTROY: OnDestroy(hwnd) ; break ;
	  case WM_SIZE: OnSize(hwnd,wParam,lParam) ; break ;
	  case WM_PAINT: BeginPaint(hwnd,&ps) ;
	                 OnPaint(hwnd,ps.hdc) ;
	                 EndPaint(hwnd,&ps) ;
	                 break ;
	  case WM_TIMER: if(wParam==IDT_TIMER_001) OnTimer(hwnd,wParam,lParam) ;
	                 break ;
	  case WM_CTLCOLORBTN: ;
	  case WM_CTLCOLOREDIT: ;
	  case WM_CTLCOLORSTATIC: ;
	  case WM_CTLCOLORLISTBOX: return OnCtlColor(hwnd,msg,wParam,lParam) ;
	  case WM_DROPFILES: OnDrop(hwnd,wParam) ; break ;
	  case WM_USER: if(wParam==IDUSR_COLORINFO) ChildWndPartsColor(lParam) ;
	                else OnUser(hwnd,wParam,lParam) ;
	                break ;
	  case WM_COMMAND: OnCommand(hwnd,wParam,lParam) ; break ;
	  default: if(!OnDefault(hwnd,msg,wParam,lParam))
	              return DefWindowProc(hwnd,msg,wParam,lParam) ;
	}
	return(0) ;
}

// --------------------------------------------------------------------
//  FrameWindow class \bh
// --------------------------------------------------------------------

HWND    HANDLEFrameWindow ;

void   FrameWindow::init(WINDOWAPPS WApp,HINSTANCE PrevI,int nCmdShow)
{
	FrameObject=WApp ;
	PrevIns=PrevI ;
	NComS=nCmdShow ;
	if(PrevIns) FWENABLE=FALSE ; // Do not work
	else        FWENABLE=TRUE ;
	if(FrameObject==NULL) FWENABLE=FALSE ;
}

FrameWindow::FrameWindow(WINDOWAPPS WApp,HINSTANCE PrevI,int nCmdShow)
{
	init(WApp,PrevI,nCmdShow) ;
}

FrameWindow::FrameWindow(WINDOWAPPS WApp,char *Menu,char *Icon,
                                        HINSTANCE PrevI,int nCmdShow)
{
	init(WApp,PrevI,nCmdShow) ;
	if(!FWENABLE) return ;
	if(Menu[0]!='\0') FrameObject->WndClass->SetMenu(Menu) ;
	if(Icon[0]!='\0') FrameObject->WndClass->SetIcon(Icon) ;
}

FrameWindow::FrameWindow(WINDOWAPPS WApp,WNDCLASSEX WcEx,
	                         HINSTANCE PrevI,int nCmdShow)
{
	init(WApp,PrevI,nCmdShow) ;
	if(!FWENABLE) return ;
	FrameObject->WndClass->SetAll(WcEx) ;
}

WPARAM FrameWindow::FrameWork(char *title,int startx,int starty,
	                      int width,int height,BOOL SizeDetect)
{
	WPARAM rv ;
	if(!FWENABLE) return(0) ;
	FrameObject->WndClass->Regist() ;
	HANDLEFrameWindow=FrameObject->Create(title,startx,starty,
	                                          width,height,SizeDetect) ;
	FrameObject->Show(NComS) ;
	rv=FrameObject->MessageLoop() ;
	return(rv) ;
}

WPARAM FrameWindow::FrameWork(char *title,int width,int height)
{
	return(FrameWork(title,-1,-1,width,height,TRUE)) ;
}

WPARAM FrameWindow::FrameWork(int width,int height)
{
	return(FrameWork("Untitled",-1,-1,width,height,TRUE)) ;
}

// --------------------------------------------------------------------
// MENUID 擾p
// --------------------------------------------------------------------

#define _DEFAULT_MENU_ID_ 6000

class _PartsID_{
	private:
	  int vMENU_ID ;
	public:
	  _PartsID_(){ vMENU_ID=_DEFAULT_MENU_ID_ ; } ;
	  ~_PartsID_(){} ;
	  HMENU Get(void){ vMENU_ID++ ; return((HMENU)vMENU_ID) ; } ;
} ;

_PartsID_ AutoID ;

// --------------------------------------------------------------------
//  CFONT Methods

CFONT::CFONT()
{
	hFont=NULL ;
	strcpy(FontFace,"FixedSys") ;
	
	nHeight=16 ;
	nWidth=0 ;
	nEscapement=0 ;
	nOrientation=0 ;
	fnWeight=FW_REGULAR ;
	fdwItalic=FALSE ;
	fdwUnderline=FALSE ;
	fdwStrikeOut=FALSE ;
	fdwCharSet=SHIFTJIS_CHARSET ;
	fdwOutputPrecision=OUT_DEFAULT_PRECIS ;
	fdwClipPrecision=CLIP_DEFAULT_PRECIS ;
	fdwQuality=PROOF_QUALITY ;
	fdwPitchAndFamily=FIXED_PITCH | FF_MODERN ;
	lpszFace=(LPCTSTR)FontFace ;
}

CFONT::~CFONT()
{
	if(NULL!=hFont) DeleteObject(hFont) ;
}

void  CFONT::set(char *facestr)
{
	if(facestr[0]!='\0') strcpy(FontFace,facestr) ;
}

void CFONT::set(char *facestr,int height,int angl)
{
	set(facestr) ;
	nHeight=height ;
	nEscapement=angl ;
}

void CFONT::set(int height,int angl)
{
	nHeight=height ;
	nEscapement=angl ;
}

void CFONT::angle(int angl)
{
	nEscapement=angl ;
}

void CFONT::use_Arial(int siz)
{
	set("Arial") ;
	fdwCharSet=ANSI_CHARSET ;
	fdwPitchAndFamily=VARIABLE_PITCH|FF_SWISS ;
	if(siz) size(siz) ;
}

void CFONT::use_Courier(int siz)
{
	set("Courier") ;
	fdwCharSet=ANSI_CHARSET ;
	fdwPitchAndFamily=VARIABLE_PITCH|FF_MODERN ;
	if(siz) size(siz) ;
}

void CFONT::use_MS_gothic(int siz)
{
	FontFace[0]=0x82 ; FontFace[1]=0x6c ; FontFace[2]=0x82 ;
	FontFace[3]=0x72 ; FontFace[4]=0x20 ; FontFace[5]=0x83 ;
	FontFace[6]=0x53 ; FontFace[7]=0x83 ; FontFace[8]=0x56 ;
	FontFace[9]=0x83 ; FontFace[10]=0x62 ; FontFace[11]=0x83 ;
	FontFace[12]=0x4e ; FontFace[13]=0x00 ;
	//set("lr SVbN") ;
	if(siz) size(siz) ;
}

void CFONT::use_MS_mincho(int siz)
{
	FontFace[0]=0x82 ; FontFace[1]=0x6c ; FontFace[2]=0x82 ;
	FontFace[3]=0x72 ; FontFace[4]=0x20 ; FontFace[5]=0x96 ;
	FontFace[6]=0xbe ; FontFace[7]=0x92 ; FontFace[8]=0xa9 ;
	FontFace[9]=0x00 ;
	//set("lr ") ;
	if(siz) size(siz) ;
}

void CFONT::use_Default(int siz)
{
	set("FixedSys") ;
	if(siz) size(siz) ;
}

void CFONT::usePreset(int PsNumb,int siz)
{
	if(PsNumb==PSFONT_ARIAL) use_Arial(siz) ;
	else if(PsNumb==PSFONT_COURIER) use_Courier(siz) ;
	else if(PsNumb==PSFONT_MINCHO) use_MS_mincho(siz) ;
	else if(PsNumb==PSFONT_GOTHIC) use_MS_gothic(siz) ;
	else use_Default(siz) ;
}

HFONT CFONT::Create(void)
{
	if(NULL==hFont)
	  hFont=CreateFont(nHeight,nWidth,nEscapement,nOrientation,fnWeight,
	             fdwItalic,fdwUnderline,fdwStrikeOut,fdwCharSet,
	             fdwOutputPrecision,fdwClipPrecision,fdwQuality,
	             fdwPitchAndFamily,lpszFace) ;
	return(hFont) ;
}

// --------------------------------------------------------------------
//  GUIParts

void GUIParts::Initialize(char *PTyp,HWND PrntH,HMENU MnID,DWORD St)
{
	strcpy(PartsType,PTyp) ;
	Parent=PrntH ;
	Mid=MnID ;
	Style=St ;
	handleWnd=NULL ;
	dwExStyle=0 ;
	thisColor.SETPARAM=0 ;
	if(Mid<(HMENU)100) Mid=AutoID.Get() ;
	FontReq=ColorReq=FALSE ;
}

void GUIParts::SetStyle(DWORD style)
{
	Style=style ;
}

void GUIParts::AddStyle(DWORD style)
{
	Style|=style ;
}

void GUIParts::DecStyle(DWORD style)
{
	DWORD st ;
	st=(Style&style) ; // YrbgIo
	Style-=st ; // ̂̕Decode
//	if((Style&style)!=0) Style-=style ;
}

void GUIParts::SetExStyle(DWORD exstyle)
{
	dwExStyle=exstyle ;
}

HWND GUIParts::Create(char *title,int sx,int sy,int wd,int ht)
{
	handleWnd=CreateWindowEx(dwExStyle,(LPCTSTR)PartsType,title,Style,
	sx,sy,wd,ht,Parent,Mid,
	ApplicationInstance,NULL) ;
	if(handleWnd!=NULL){ // Font,Color̃Zbg
	  if(FontReq)
	    SendMsg(WM_SETFONT,(WPARAM)FONT.GetFont(),0l) ;
	  if(ColorReq){
	    thisColor.WNDHANDLE=handleWnd ;
	    SetPartsColor() ;
	  }
	}
	return(handleWnd) ;
}

HWND GUIParts::GetHandle(void)
{
	return(handleWnd) ;
}

LRESULT GUIParts::SendMsg(UINT Msg,WPARAM wParam,LPARAM lParam)
{
	if(handleWnd==NULL) return((LRESULT)0) ;
	else return(::SendMessage(handleWnd,Msg,wParam,lParam)) ;
}

void GUIParts::PostMsg(UINT Msg,WPARAM wParam,LPARAM lParam)
{
	if(handleWnd!=NULL)
	  ::PostMessage(handleWnd,Msg,wParam,lParam) ;
}

HMENU GUIParts::GetMenuID(void)
{
	return(Mid) ;
}

BOOL  GUIParts::IsYourEvent(WPARAM mID)
{
	return((HMENU)mID==Mid) ;
}

void GUIParts::Enable(BOOL sw)
{
	EnableWindow(handleWnd,sw) ;
}

void GUIParts::SetFont(void)
{
	if(!FONT.Active()) FONT.Create() ;
	FontReq=FALSE ;
	if(handleWnd==NULL) FontReq=TRUE ; // ܂ACreateĂȂꍇ́A
	                                   // oĂZbglɂB
	else SendMsg(WM_SETFONT,(WPARAM)FONT.GetFont(),0l) ;
}

void GUIParts::SetFont(HFONT hFont)
{
	FontReq=FALSE ;
	if(handleWnd==NULL) return ; // SetFont́AۑoȂ̂ŁA
	                             // CreateĂȂ΁AsB
	SendMsg(WM_SETFONT,(WPARAM)hFont,0l) ;
}

//	  void SetFont(char *FFace,int siz) ;
//	  void SetFont(int FontPresetNumb,int siz) ;

void GUIParts::SetFont(char *FFace,int siz,int angl)
{
	FONT.set(FFace,siz,angl) ;
	SetFont() ;
}

void GUIParts::SetFont(int FontPresetNumb,int siz,int angl)
{
	FONT.usePreset(FontPresetNumb,siz) ;
	FONT.angle(angl) ;
	SetFont() ;
}

// --------------------------------------------------------------------
// Font Color,,PostMessageɂđΉĂAWindows9xnŁA
// ^C~OxׁAɓ삵ȂsoCSendMessageɂđΉ
// AeEChEWM_CREATEɁAeEChEɑ΂āA
// SendMessagêA኱ŝŁAeEChẼnhA
// WinAppNXւ̃|C^擾āAڃZbglύXB
// ́AWinAppŁANX̃vV[WgĂ鎞̂ݗLłB
// ȊȌꍇɂẮAPostMessage(WM_USER,IDUSR_COLORINFO)ɂāA
// ݒ𑗂鎖ɂȂ̂ŁA[UÃbZ[WnhȂ΁A
// ȂȂBWinApp::WindowProcɁA󂯎dg݂݂͐A
// ʏA͌Ă΂ȂB
// AWindows9xnł́AFontColorZbgہAWM_CTLCOLORxxxւ̕ԓŁA
// KmHBRUSHԂȂƁA((HBRUSH)0ł͑ʖ)܊pZbgtHgF
// AftHggĂ܂̂ŁAFwɂ́AKABACKGROUND
// w肷lɂB

void GUIParts::SetPartsColor(void)
{
	WinApp *ParentClass=(WinApp*)GetWindowLong(Parent,0) ;
	ColorReq=FALSE ;
	if(ParentClass!=0){
	  if(handleWnd==NULL) ColorReq=TRUE ;
	  else ParentClass->ChildWndColor(&thisColor) ;
	}
	else{ // AWinAppWndProcgpĂȂ̂ŁAPostMessage
	  if(handleWnd==NULL) ColorReq=TRUE ;
	  else PostMessage(Parent,WM_USER,IDUSR_COLORINFO,(LPARAM)&thisColor) ;
	}
}

void GUIParts::SetFontColor(int r,int g,int b)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.TEXTCOLOR=RGBcolor(r,g,b) ;
	thisColor.SETPARAM|=0x0001 ;
	if(!(thisColor.SETPARAM&0x0002)) SetBGColorEx(WHITE_BRUSH) ;
	SetPartsColor() ;
}

void GUIParts::SetFontColor(COLORREF col)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.TEXTCOLOR=col ;
	thisColor.SETPARAM|=0x0001 ;
	if(!(thisColor.SETPARAM&0x0002)) SetBGColorEx(WHITE_BRUSH) ;
	SetPartsColor() ;
}

void GUIParts::SetTEXTBGColor(int r,int g,int b)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.TEXTBG=RGBcolor(r,g,b) ;
	thisColor.SETPARAM|=0x0004 ;
	if(!(thisColor.SETPARAM&0x0002)) SetBGColorEx(WHITE_BRUSH) ;
	SetPartsColor() ;
}

void GUIParts::SetTEXTBGColor(COLORREF col)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.TEXTBG=col ;
	thisColor.SETPARAM|=0x0004 ;
	if(!(thisColor.SETPARAM&0x0002)) SetBGColorEx(WHITE_BRUSH) ;
	SetPartsColor() ;
}

void GUIParts::SetBGColor(HBRUSH brush)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.BACKGROUND=brush ;
	thisColor.SETPARAM|=0x0002 ;
	SetPartsColor() ;
}

void GUIParts::SetBGColor(int fnObject)
{
	thisColor.WNDHANDLE=handleWnd ;
	thisColor.BACKGROUND=(HBRUSH)GetStockObject(fnObject) ;
	thisColor.SETPARAM|=0x0002 ;
	SetPartsColor() ;
}

// ́AFONTFw肵ꍇɁAKBACKGROUNDBRUSHZbgׂ
// dg݁Bprivate

void GUIParts::SetBGColorEx(int fnObject)
{
	thisColor.BACKGROUND=(HBRUSH)GetStockObject(fnObject) ;
	thisColor.SETPARAM|=0x0002 ;
}

// --------------------------------------------------------------------
//  Button

PushButton::PushButton(HWND ParentH,HMENU MenuID)
{
	Initialize("BUTTON",ParentH,MenuID,BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE) ;
}

PushButton::PushButton(HWND ParentH)
{
	Initialize("BUTTON",ParentH,(HMENU)0,BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE) ;
}

// -- Other Buttons

RadioButton::RadioButton(HWND ParentH,HMENU MenuID)
{
	Initialize("BUTTON",ParentH,MenuID,BS_RADIOBUTTON|WS_CHILD|WS_VISIBLE) ;
}

RadioButton::RadioButton(HWND ParentH)
{
	Initialize("BUTTON",ParentH,(HMENU)0,BS_RADIOBUTTON|WS_CHILD|WS_VISIBLE) ;
}

void RadioButton::Check(BOOL sw)
{
	if(handleWnd==NULL) return ;
	if(sw) SendMessage(handleWnd,BM_SETCHECK,(WPARAM)BST_CHECKED,0) ;
	else   SendMessage(handleWnd,BM_SETCHECK,(WPARAM)BST_UNCHECKED,0) ;
}

BOOL RadioButton::Check(void)
{
	int ck ;
	if(handleWnd==NULL) return(FALSE) ;
	ck=SendMessage(handleWnd,BM_GETCHECK,0,0) ;
	return(ck==BST_CHECKED) ;
}

//

CheckBox::CheckBox(HWND ParentH,HMENU MenuID)
{
	Initialize("BUTTON",ParentH,MenuID,BS_CHECKBOX|WS_CHILD|WS_VISIBLE) ;
}

CheckBox::CheckBox(HWND ParentH)
{
	Initialize("BUTTON",ParentH,(HMENU)0,BS_CHECKBOX|WS_CHILD|WS_VISIBLE) ;
}

void CheckBox::Check(BOOL sw)
{
	if(handleWnd==NULL) return ;
	if(sw) SendMessage(handleWnd,BM_SETCHECK,(WPARAM)BST_CHECKED,0) ;
	else   SendMessage(handleWnd,BM_SETCHECK,(WPARAM)BST_UNCHECKED,0) ;
}

BOOL CheckBox::Check(void)
{
	int ck ;
	if(handleWnd==NULL) return(FALSE) ;
	ck=SendMessage(handleWnd,BM_GETCHECK,0,0) ;
	return(ck==BST_CHECKED) ;
}

// --------------------------------------------------------------------
// SimpleEdit

SimpleEdit::SimpleEdit(HWND ParentH,HMENU MenuID,BOOL BORDER,BOOL SCROLL)
{
	Initialize("EDIT",ParentH,MenuID,ES_MULTILINE|WS_CHILD|WS_VISIBLE) ;
	if(BORDER) AddStyle(WS_BORDER) ;
	if(SCROLL) AddStyle(WS_VSCROLL) ;
}

SimpleEdit::SimpleEdit(HWND ParentH,BOOL BORDER,BOOL SCROLL)
{
	Initialize("EDIT",ParentH,(HMENU)0,ES_MULTILINE|WS_CHILD|WS_VISIBLE) ;
	if(BORDER) AddStyle(WS_BORDER) ;
	if(SCROLL) AddStyle(WS_VSCROLL) ;
}

void SimpleEdit::SingleLine(void)
{
	DecStyle(ES_MULTILINE) ;
}

void SimpleEdit::AddString(char *str)
{
	int i,c ;
	unsigned int *ch ;
	for(i=0 ; str[i]!='\0' ; i++){
	  c=(str[i]&0x00ff) ;
	  if(((c>=0x0080 && c<=0x009f) || (c>=0xe0 && c<=0xfc)) && str[i+1]!='\0'){
	    ch=(unsigned int *)&str[i] ;
	    c=*ch ; i++ ;
	  }
	  SendMsg(WM_CHAR,c,NULL) ;
	}
}

void SimpleEdit::AddChar(int c)
{
	SendMsg(WM_CHAR,c,NULL) ;
}

void SimpleEdit::SetWindowText(char *txt)
{
	::SetWindowText(handleWnd,txt) ;
}

void SimpleEdit::GetWindowText(char *txt,int len)
{
	::GetWindowText(handleWnd,txt,len) ;
}

// --------------------------------------------------------------------
// Label

Label::Label(HWND ParentH,HMENU MenuID,BOOL BORDER)
{
	Initialize("STATIC",ParentH,MenuID,SS_LEFT|WS_CHILD|WS_VISIBLE) ;
	if(BORDER) AddStyle(WS_BORDER) ;
}

Label::Label(HWND ParentH,BOOL BORDER)
{
	Initialize("STATIC",ParentH,(HMENU)0,SS_LEFT|WS_CHILD|WS_VISIBLE) ;
	if(BORDER) AddStyle(WS_BORDER) ;
}

void Label::SetWindowText(char *txt)
{
	::SetWindowText(handleWnd,txt) ;
}

void Label::GetWindowText(char *txt,int len)
{
	::GetWindowText(handleWnd,txt,len) ;
}

// --------------------------------------------------------------------
// ListBox

ListBox::ListBox(HWND ParentH,HMENU MenuID)
{
	Initialize("LISTBOX",ParentH,MenuID,
	              WS_VSCROLL|WS_CHILD|WS_VISIBLE|WS_BORDER|LBS_NOTIFY) ;
	
}

ListBox::ListBox(HWND ParentH)
{
	Initialize("LISTBOX",ParentH,(HMENU)0,
	              WS_VSCROLL|WS_CHILD|WS_VISIBLE|WS_BORDER|LBS_NOTIFY) ;
}

void ListBox::AddString(char *txt)
{
	SendMessage(handleWnd,LB_ADDSTRING,0,(LPARAM)txt) ;
}

void ListBox::SetCurSel(int pos)
{
	SendMessage(handleWnd,LB_SETCURSEL,(WPARAM)pos,0l) ;
}

int ListBox::GetSelected(char *txt)
{
	int selnb=SendMessage(handleWnd,LB_GETCURSEL,0,0l) ;
	SendMessage(handleWnd,LB_GETTEXT,(WPARAM)selnb,(LPARAM)txt) ;
	return(selnb) ;
}

// --------------------------------------------------------------------
// ComboBox

ComboBox::ComboBox(HWND ParentH,HMENU MenuID)
{
	Initialize("COMBOBOX",ParentH,MenuID,
	              CBS_DROPDOWN|WS_VSCROLL|WS_CHILD|WS_VISIBLE) ;
}

ComboBox::ComboBox(HWND ParentH)
{
	Initialize("COMBOBOX",ParentH,(HMENU)0,
	              CBS_DROPDOWN|WS_VSCROLL|WS_CHILD|WS_VISIBLE) ;
}

void ComboBox::Simple(void)
{
	Style=CBS_DROPDOWN|WS_VSCROLL|WS_CHILD|WS_VISIBLE|CBS_SIMPLE ;
}

void ComboBox::AddString(char *txt)
{
	SendMessage(handleWnd,CB_ADDSTRING,0,(LPARAM)txt) ;
}

void ComboBox::SetCurSel(int pos)
{
	SendMessage(handleWnd,CB_SETCURSEL,(WPARAM)pos,0l) ;
}

int ComboBox::GetSelected(char *txt)
{
	int selnb=SendMessage(handleWnd,CB_GETCURSEL,0,0l) ;
	GetWindowText(handleWnd,txt,32) ;
//	SendMessage(handleWnd,CB_GETCURSEL,0,0l) ;
//	(WPARAM)selnb,(LPARAM)txt) ;
	return(selnb) ;
}

// --------------------------------------------------------------------
// 


void RadioBtnWork::push(int nb)
{
	int i ;
	if(nb<0 || nb>=registed) return ;
	for(i=0 ; i<registed ; i++){
	  RB[i]->Check(FALSE) ;
	}
	RB[nb]->Check(TRUE) ;
	mark=nb ;
}

void RadioBtnWork::VirtCreate(int startx,int starty,int width,int each_height)
{
	int i,y,h ;
	y=starty ; h=each_height-1 ;
	for(i=0 ; i<registed ; i++){
	  RB[i]->Create(RBStr[i],startx,y,width,h) ;
	  y+=each_height ;
	}
}

void RadioBtnWork::HolzCreate(int startx,int starty,int each_width,int height)
{
	int i,x,w ;
	x=startx ; w=each_width-1 ;
	for(i=0 ; i<registed ; i++){
	  RB[i]->Create(RBStr[i],x,starty,w,height) ;
	  x+=each_width ;
	}
}

void RadioBtnWork::setWndStr(int nb,char *wstr)
{
	int i ;
	if(nb>=RBWMAX) return ;
	for(i=0 ; i<127 ; i++){
	  RBStr[nb][i]=wstr[i] ;
	  if(wstr[i]=='\0') break ;
	}
	RBStr[nb][i]='\0' ;
}

BOOL RadioBtnWork::IsYourJob(WPARAM wP)
{
	int i,f ;
	f=0 ;
	for(i=0 ; i<registed ; i++){
	  if(RB[i]->IsYourEvent(wP)){
	    push(i) ;
	    f=1 ; break ;
	  }
	}
	if(f) return(TRUE) ;
	return(FALSE) ;
}

void RadioBtnWork::DeleteAll(void)
{
	int i ;
	for(i=0 ; i<registed ; i++){
	 if(RBS[i]) delete RB[i] ; // ̂ƂōźA
	}
	registed=mark=0 ;
}

void RadioBtnWork::Enable(BOOL sw)
{
	int i ;
	for(i=0 ; i<registed ; i++){
	  RB[i]->Enable(sw) ;
	}
}

// --------------------------------------------------------------------
//  Profile

void AppProfile::BootEnable(BOOL sw)
{
	if(sw) WritePrivateProfileString("COMMON","BOOT","1",ProfileName) ;
	else   WritePrivateProfileString("COMMON","BOOT","0",ProfileName) ;
}

int  AppProfile::BootEnable(void)
{
	int x=GetPrivateProfileInt("COMMON","BOOT",-1,ProfileName) ;
	if(x==-1){
	  BootEnable(FALSE) ; return(1) ;
	}
	return(x) ;
}

void AppProfile::CommPort(int numb)
{
	char cbf[32] ;
	wsprintf(cbf,"%d",numb) ;
	WritePrivateProfileString("COMMON","COMM",cbf,ProfileName) ;
}

int AppProfile::CommPort(void)
{
	int x=GetPrivateProfileInt("COMMON","COMM",-1,ProfileName) ;
	if(x==-1){
	  CommPort(0) ; return(0) ;
	}
	return(x) ;
}

